/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Michael Fiedler     - initial API and implementation for Bugzilla adapter
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/
package se.kth.md.assume.adaptors.pror.services;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.core.UriBuilder;

import org.apache.wink.json4j.JSONObject;
import org.eclipse.lyo.oslc4j.provider.json4j.JsonHelper;
import org.eclipse.lyo.oslc4j.core.annotation.OslcCreationFactory;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialog;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialogs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcQueryCapability;
import org.eclipse.lyo.oslc4j.core.annotation.OslcService;
import org.eclipse.lyo.oslc4j.core.model.Compact;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.OslcMediaType;
import org.eclipse.lyo.oslc4j.core.model.Preview;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;

import se.kth.md.assume.adaptors.pror.ProRManager;
import se.kth.md.assume.adaptors.pror.ProRConstants;
import se.kth.md.assume.adaptors.pror.servlet.ServiceProviderCatalogSingleton;
import se.kth.md.assume.adaptors.pror.resources.Requirement;
import se.kth.md.assume.adaptors.pror.resources.RequirementCollection;

// Start of user code imports
// End of user code

// Start of user code pre_class_code
// End of user code
@OslcService(ProRConstants.REQUIREMENTS_MANAGEMENT_DOMAIN)
@Path("rm-services/{serviceProviderId}/resources")
public class RequirementAndRequirementCollectionService
{
    @Context private HttpServletRequest httpServletRequest;
    @Context private HttpServletResponse httpServletResponse;
    @Context private UriInfo uriInfo;

    // Start of user code class_attributes
    // End of user code

    // Start of user code class_methods
    // End of user code

    public RequirementAndRequirementCollectionService()
    {
        super();
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityReq",
        label = "",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + ProRConstants.PATH_REQUIREMENT,
        resourceTypes = {ProRConstants.TYPE_REQUIREMENT},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("requirements")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public Requirement[] queryRequirements(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryRequirements
        // Here additional logic can be implemented that complements main action taken in ProRManager
        // End of user code

        final List<Requirement> resources = ProRManager.queryRequirements(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new Requirement [resources.size()]);
    }

    @GET
    @Path("requirements")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryRequirementsAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryRequirementsAsHtml
        // End of user code

        final List<Requirement> resources = ProRManager.queryRequirements(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryRequirementsAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/pror/requirementscollection.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityReqColl",
        label = "",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + ProRConstants.PATH_REQUIREMENTCOLLECTION,
        resourceTypes = {ProRConstants.TYPE_REQUIREMENTCOLLECTION},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("collections")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public RequirementCollection[] queryRequirementCollections(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryRequirementCollections
        // Here additional logic can be implemented that complements main action taken in ProRManager
        // End of user code

        final List<RequirementCollection> resources = ProRManager.queryRequirementCollections(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new RequirementCollection [resources.size()]);
    }

    @GET
    @Path("collections")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryRequirementCollectionsAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryRequirementCollectionsAsHtml
        // End of user code

        final List<RequirementCollection> resources = ProRManager.queryRequirementCollections(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryRequirementCollectionsAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/pror/requirementcollectionscollection.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcDialog
    (
         title = "SelectionDialogRequirement",
         label = "SelectionDialogRequirement",
         uri = "rm-services/{serviceProviderId}/resources/requirementSelector",
         hintWidth = "0px",
         hintHeight = "0px",
         resourceTypes = {ProRConstants.TYPE_REQUIREMENT},
         usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("requirementSelector")
    @Consumes({ MediaType.TEXT_HTML, MediaType.WILDCARD })
    public void RequirementSelector(
        @QueryParam("terms") final String terms
        , @PathParam("serviceProviderId") final String serviceProviderId
        ) throws ServletException, IOException
    {
        try {
            // Start of user code RequirementSelector_init
            // End of user code

            httpServletRequest.setAttribute("selectionUri",uriInfo.getAbsolutePath().toString());
            // Start of user code RequirementSelector_setAttributes
            // End of user code

            if (terms != null ) {
                httpServletRequest.setAttribute("terms", terms);
                final List<Requirement> resources = ProRManager.RequirementSelector(httpServletRequest, serviceProviderId, terms);
                if (resources!= null) {
                            httpServletRequest.setAttribute("resources", resources);
                            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/pror/requirementselectorresults.jsp");
                            rd.forward(httpServletRequest, httpServletResponse);
                }
                //a empty search should return an empty list and not NULL!
                throw new WebApplicationException(Status.NOT_FOUND);

            } else {
                try {
                    RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/pror/requirementselector.jsp");
                    rd.forward(httpServletRequest, httpServletResponse);
                } catch (Exception e) {
                    throw new ServletException(e);
                }
            }
        } catch (Exception e) {
            throw new WebApplicationException(e);
        }
    }

    @GET
    @Path("requirements/{requirementId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public Requirement getRequirement(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("requirementId") final String requirementId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final Requirement aRequirement = ProRManager.getRequirement(httpServletRequest, serviceProviderId, requirementId);

        if (aRequirement != null) {
            // Start of user code getRequirement
            // End of user code
            return aRequirement;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("requirements/{requirementId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getRequirementAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("requirementId") final String requirementId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getRequirementAsHtml_init
        // End of user code

        final Requirement aRequirement = ProRManager.getRequirement(httpServletRequest, serviceProviderId, requirementId);

        if (aRequirement != null) {
            httpServletRequest.setAttribute("aRequirement", aRequirement);
            // Start of user code getRequirementAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/pror/requirement.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("requirementCollections/{requirementCollectionId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public RequirementCollection getRequirementCollection(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("requirementCollectionId") final String requirementCollectionId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final RequirementCollection aRequirementCollection = ProRManager.getRequirementCollection(httpServletRequest, serviceProviderId, requirementCollectionId);

        if (aRequirementCollection != null) {
            // Start of user code getRequirementCollection
            // End of user code
            return aRequirementCollection;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("requirementCollections/{requirementCollectionId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getRequirementCollectionAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("requirementCollectionId") final String requirementCollectionId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getRequirementCollectionAsHtml_init
        // End of user code

        final RequirementCollection aRequirementCollection = ProRManager.getRequirementCollection(httpServletRequest, serviceProviderId, requirementCollectionId);

        if (aRequirementCollection != null) {
            httpServletRequest.setAttribute("aRequirementCollection", aRequirementCollection);
            // Start of user code getRequirementCollectionAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/assume/adaptors/pror/requirementcollection.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

}
